import sys
import numpy as np
import cv2 as cv
from matplotlib import pyplot as plt

def GetRect(file_4p, w, h, padding):
    x_min = w
    x_max = 0 
    y_min = h
    y_max = 0
    fp = open(file_4p, "r")
    for line in fp:
        l = line.strip()
        if l != "":
            C = l.split()
            x = int(C[0])
            y = int(C[1])
            if x < x_min:
                x_min = x
            if x > x_max:
                x_max = x
            if y < y_min:
                y_min = y
            if y > y_max:
                y_max = y
    fp.close()
    y_min = max(0, y_min - padding)
    x_min = max(0, x_min - padding)
    y_max = min(h-1, y_max + padding)
    x_max = min(w-1, x_max + padding)
    return (x_min, y_min, x_max-x_min+1, y_max-y_min+1)
    

def main():
    #print(sys.argv)
    img = cv.imread(sys.argv[1]) #'dat/flower03/flower03_small.jpg')
    print(img.shape)
    h, w, c = img.shape
    #print("w:",w," h:",h)

    mask = np.zeros(img.shape[:2],np.uint8)

    bgdModel = np.zeros((1,65),np.float64)
    fgdModel = np.zeros((1,65),np.float64)

    #x,y,w,h
    #rect = (44,28,274,253)
    rect = GetRect(sys.argv[2], w, h, 3) #3)
    print(rect)
    niter = 5
    cv.grabCut(img,mask,rect,bgdModel,fgdModel,niter,cv.GC_INIT_WITH_RECT)

    mask2 = np.where((mask==2)|(mask==0),0,1).astype('uint8')

    cv.imwrite('result.pgm', mask2)
    #img = img*mask2[:,:,np.newaxis]
    #plt.imshow(img),plt.colorbar(),plt.show()

    
main()
