
#ifndef _GFT_CONNSEEDS_H_
#define _GFT_CONNSEEDS_H_

#include "gft.h"

#define CONNPOWER 3.5



typedef struct _IFTData{
  gft::sImage32 *pred;
  double *cost;
} IFTData;


typedef struct _ROI{
  int y_min;
  int x_min;
  int y_max;
  int x_max;
} ROI;


void GetROI(ROI *roi,
	    int *P4,
	    gft::sImage32 *img,
	    int padding);

int *Load4Points(char *filename, gft::sImage32 *img);

void IFTesum_pow(gft::sImage32 *energy,
		 int *S,
		 gft::sImage32 *pred,
		 double *cost,
		 double power,
		 int *pixels);

int FindMinJunctionPoint(gft::sImage32 *energy,
			 int Emax,
			 IFTData *ift_data,
			 int n,
			 double *emin,
			 int *pixels);

int FindMinJunctionPoint(gft::sImage32 *energy,
			 int Emax,
			 double *cost1,
			 double *cost2,
			 double *cost3,
			 double *emin,
			 int *pixels);

void ThreePointConnection(gft::sImage32 *energy,
			  IFTData *ift_data,
			  int *color,
			  int *pixels);

void WriteFourPointConnection(int p, int q,
			      gft::sImage32 *energy,
			      gft::sImage32 *pred[6],
			      int *color);

double OrderedFourPointConnection(gft::sImage32 *energy,
				  IFTData *ift_data,
				  int *color,
				  int *pixels);

double ApproximateOrderedFourPointConnection(gft::sImage32 *energy,
					     IFTData *ift_data,
					     int *color,
					     int *pixels);

void FourPointConnection(gft::sImage32 *energy,
			 IFTData *ift_data,
			 int *color,
			 int *pixels,
			 bool opt);

int *SetColorArray(int n);

int *GetCandidatePixels(gft::sImage32 *energy,
			ROI *roi);


#endif
